# -*- coding: utf-8 -*-

import base64


def rc4_crypt(data, key):
    s_range = range(256)
    j = 0
    out = []
    #KSA Phase
    for i in range(256):
        j = (j + s_range[i] + ord(key[i % len(key)])) % 256
        s_range[i], s_range[j] = s_range[j], s_range[i]
    #PRGA Phase
    for char in data:
        i = j = 0
        i = (i + 1) % 256
        j = (j + s_range[i]) % 256
        s_range[i], s_range[j] = s_range[j], s_range[i]
        out.append(chr(ord(char) ^ s_range[(s_range[i] + s_range[j]) % 256]))
    return ''.join(out)


def encrypt(data, key, encode=base64.b64encode):
    data = rc4_crypt(data, key)
    if encode:
        data = encode(data)
    return data


def decrypt(data, key, decode=base64.b64decode):
    if decode:
        data = decode(data)
    return rc4_crypt(data, key)
